-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

THConstructionBrushPlaceable = {}
function THConstructionBrushPlaceable.onAxisChangeColorScale(self, inputValue)
local function protectedFunc()
local envData = g_thMain:getDataTable(self)
local placeable = self.placeable
if envData and placeable and placeable.getAvailableColors ~= nil then
local colorableSpecData = g_thMain:getDataTable(placeable.spec_colorable)
if colorableSpecData and colorableSpecData.hasExtendedColors then
local colorScaleIndex = envData.colorScaleIndex
local isFullCycle = false
colorScaleIndex = colorScaleIndex + inputValue
while true do
if colorScaleIndex > THPlaceableColorable.MAX_NUM_COLOR_SCALES then
if isFullCycle then break end
colorScaleIndex = 1
isFullCycle = true
elseif colorScaleIndex <= 0 then
if isFullCycle then break end
colorScaleIndex = THPlaceableColorable.MAX_NUM_COLOR_SCALES
isFullCycle = true
end
local colorsList = colorableSpecData:getAvailableColorsAtIndex(colorScaleIndex)
if colorsList and #colorsList > 0 then
envData.colorScaleIndex = colorScaleIndex
break
end
if inputValue < 0 then
colorScaleIndex = colorScaleIndex - 1
else
colorScaleIndex = colorScaleIndex + 1
end
end
colorableSpecData.colorScaleIndex = envData.colorScaleIndex
self.colorIndex = placeable:getColor()
self:setInputTextDirty()
end
end
end
g_thMain:pcall(protectedFunc)
end
function THConstructionBrushPlaceable.getAxisChangeColorScaleText(self, envData)
if  g_thMain:argIsValid(type(self) == "table", "self", self)
and g_thMain:argIsValid(type(envData) == "table", "envData", envData)
then
local placeable = self.placeable
if placeable then
local colorableSpecData = g_thMain:getDataTable(placeable.spec_colorable)
if colorableSpecData and colorableSpecData.hasExtendedColors then
local colorScaleIndex = colorableSpecData.colorScaleIndex
local text = nil
if g_i18n:hasText("input_THPC_CHANGE_COLOR_SCALE") then
text = g_i18n:getText("input_THPC_CHANGE_COLOR_SCALE")
text = string.format(text, colorScaleIndex)
return text
end
end
end
end
end
function THConstructionBrushPlaceable.hook_new(superFunc, ...)
local newEnv, ra,rb,rc,rd,re = superFunc(...)
local function appendFunc()
if newEnv then
local envData = g_thMain:createDataTable(newEnv)
envData.supportsChangeColorScaleAxis = newEnv.supportsPrimaryAxis
envData.changeColorScaleAxisIsContinuous = newEnv.primaryAxisIsContinuous
envData.colorScaleIndex = 1
envData.getAxisChangeColorScaleText = function()
return THConstructionBrushPlaceable.getAxisChangeColorScaleText(newEnv, envData)
end
end
end
g_thMain:pcall(appendFunc)
return newEnv, ra,rb,rc,rd,re
end
function THConstructionBrushPlaceable:hook_loadedPlaceable(superFunc, placeable, loadingState, args, ...)
local ra,rb,rc,rd,re = superFunc(self, placeable, loadingState, args, ...)
local function appendFunc()
local envData = g_thMain:getDataTable(self)
if envData and placeable and placeable.setColor ~= nil then
local colorableSpecData = g_thMain:getDataTable(placeable.spec_colorable)
if colorableSpecData and colorableSpecData.hasExtendedColors then
local colorsList = colorableSpecData:getAvailableColorsAtIndex(envData.colorScaleIndex)
if #colorsList > 0 then
colorableSpecData.colorScaleIndex = envData.colorScaleIndex
else
envData.colorScaleIndex = colorableSpecData.colorScaleIndex
end
colorableSpecData:setAllColors()
end
end
end
g_thMain:pcall(appendFunc)
return ra,rb,rc,rd,re
end
function THConstructionBrushPlaceable:hook_onButtonPrimary(superFunc, ...)
local buyPlaceableEventNew_old = false
local function prependFunc()
local placeable = self.placeable
if placeable ~= nil then
local colorableSpecData = g_thMain:getDataTable(placeable.spec_colorable)
if colorableSpecData and colorableSpecData.hasExtendedColors then
local colorIndexList = {}
for i = 1, THPlaceableColorable.MAX_NUM_COLOR_SCALES do
colorIndexList[i] = colorableSpecData.colorIndex[i]
end
local buyPlaceableEventNewFunc = BuyPlaceableEvent.new
buyPlaceableEventNew_old = rawget(BuyPlaceableEvent, "new")
rawset(BuyPlaceableEvent, "new", function(pFilename, px,py,pz, prx,pry,prz, pDisplacementCosts, pOwnerFarmId, pModifyTerrain, pColorIndex, ...)
return buyPlaceableEventNewFunc(pFilename, px,py,pz, prx,pry,prz, pDisplacementCosts, pOwnerFarmId, pModifyTerrain, colorIndexList, ...)
end)
end
end
end
g_thMain:pcall(prependFunc)
local ra,rb,rc,rd,re = superFunc(self, ...)
if buyPlaceableEventNew_old ~= false then rawset(BuyPlaceableEvent, "new", buyPlaceableEventNew_old) end
return ra,rb,rc,rd,re
end
g_thMain:hookFunction(ConstructionBrushPlaceable, "new",             THConstructionBrushPlaceable, nil, false)
g_thMain:hookFunction(ConstructionBrushPlaceable, "loadedPlaceable", THConstructionBrushPlaceable)
g_thMain:hookFunction(ConstructionBrushPlaceable, "onButtonPrimary", THConstructionBrushPlaceable)