-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

THConstructionScreen = {}
function THConstructionScreen.onAxisChangeColorScale(self, actionName, inputValue, ...)
local function protectedFunc()
if self.brush then
THConstructionBrushPlaceable.onAxisChangeColorScale(self.brush, inputValue)
end
end
g_thMain:pcall(protectedFunc)
end
function THConstructionScreen:hook_update(superFunc, dt, ...)
local function prependFunc()
local envData = g_thMain:getDataTable(self)
if not envData then
envData = g_thMain:createDataTable(self)
end
end
g_thMain:pcall(prependFunc)
return superFunc(self, dt, ...)
end
function THConstructionScreen:hook_updateBrushActionTexts(superFunc, ...)
local ra,rb,rc,rd,re = superFunc(self, ...)
local function appendFunc()
local envData = g_thMain:getDataTable(self)
if envData then
if envData.changeColorScaleEvent then
local brushData = g_thMain:getDataTable(self.brush)
local text = nil
if brushData and brushData.getAxisChangeColorScaleText ~= nil then
text = brushData:getAxisChangeColorScaleText()
if text ~= nil then
self.inputManager:setActionEventText(envData.changeColorScaleEvent, text)
end
end
self.inputManager:setActionEventTextVisibility(envData.changeColorScaleEvent, text ~= nil)
self.inputManager:setActionEventActive(envData.changeColorScaleEvent, text ~= nil)
end
end
end
g_thMain:pcall(appendFunc)
return ra,rb,rc,rd,re
end
function THConstructionScreen:hook_removeBrushActionEvents(superFunc, ...)
local ra,rb,rc,rd,re = superFunc(self, ...)
local function appendFunc()
local envData = g_thMain:getDataTable(self)
if envData then
envData.changeColorScaleEvent = nil
end
end
g_thMain:pcall(appendFunc)
return ra,rb,rc,rd,re
end
function THConstructionScreen:hook_registerBrushActionEvents(superFunc, ...)
local ra,rb,rc,rd,re = superFunc(self, ...)
local function appendFunc()
local envData = g_thMain:getDataTable(self)
local brushData = g_thMain:getDataTable(self.brush)
if envData and brushData then
envData.changeColorScaleEvent = nil
if brushData.supportsChangeColorScaleAxis then
local _, actionEventId = self.inputManager:registerActionEvent(InputAction.THPC_AXIS_CHANGE_COLOR_SCALE, self, THConstructionScreen.onAxisChangeColorScale, false, not brushData.changeColorScaleAxisIsContinuous, brushData.changeColorScaleAxisIsContinuous, true)
self.inputManager:setActionEventTextPriority(actionEventId, GS_PRIO_HIGH)
table.insert(self.brushEvents, actionEventId)
envData.changeColorScaleEvent = actionEventId
end
end
end
g_thMain:pcall(appendFunc)
return ra,rb,rc,rd,re
end
g_thMain:hookFunction(ConstructionScreen, "update",                    THConstructionScreen)
g_thMain:hookFunction(ConstructionScreen, "updateBrushActionTexts",    THConstructionScreen)
g_thMain:hookFunction(ConstructionScreen, "removeBrushActionEvents",   THConstructionScreen)
g_thMain:hookFunction(ConstructionScreen, "registerBrushActionEvents", THConstructionScreen)