-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

THBuyPlaceableEvent = {}
function THBuyPlaceableEvent.hook_new(superFunc, filename, x,y,z, rx,ry,rz, displacementCosts, ownerFarmId, modifyTerrain, colorIndex, ...)
local colorIndexType = type(colorIndex)
local colorIndexList = {}
for i = 1, THPlaceableColorable.MAX_NUM_COLOR_SCALES do
if colorIndexType == "table" and colorIndex[i] ~= nil then
colorIndexList[i] = colorIndex[i]
else
colorIndexList[i] = 0
end
end
if colorIndexType == "table" then
colorIndex = 1
end
local newEnv, ra,rb,rc,rd,re = superFunc(filename, x,y,z, rx,ry,rz, displacementCosts, ownerFarmId, modifyTerrain, colorIndex, ...)
if newEnv then
local envData = g_thMain:createDataTable(newEnv, true)
envData.colorIndex = colorIndexList
end
return newEnv, ra,rb,rc,rd,re
end
function THBuyPlaceableEvent:hook_readStream(superFunc, streamId, connection, ...)
if not connection:getIsServer() then
local envData = g_thMain:createDataTable(self, true)
envData.colorIndex = {}
for i = 1, THPlaceableColorable.MAX_NUM_COLOR_SCALES do
envData.colorIndex[i] = streamReadUInt8(streamId)
end
end
return superFunc(self, streamId, connection)
end
function THBuyPlaceableEvent:hook_writeStream(superFunc, streamId, connection, ...)
if connection:getIsServer() then
local envData = g_thMain:getDataTable(self)
for i = 1, THPlaceableColorable.MAX_NUM_COLOR_SCALES do
streamWriteUInt8(streamId, envData.colorIndex[i])
end
end
return superFunc(self, streamId, connection)
end
function THBuyPlaceableEvent:hook_placeableLoaded(superFunc, placeable, loadingState, args, ...)
local placeableSetColor_old = false
if placeable and placeable.setColor ~= nil then
local envData = g_thMain:getDataTable(self, true)
if envData.colorIndex then
local colorableSpecData = g_thMain:getDataTable(placeable.spec_colorable)
if colorableSpecData and colorableSpecData.hasExtendedColors then
for i = 1, THPlaceableColorable.MAX_NUM_COLOR_SCALES do
colorableSpecData.colorIndex[i] = envData.colorIndex[i]
end
local placeableSetColorFunc = placeable.setColor
placeableSetColor_old = rawget(placeable, "setColor")
rawset(placeable, "setColor", function(pSelf, pIndex, ...)
local vra,vrb,vrc,vrd,vre = placeableSetColorFunc(pSelf, 0, ...)
colorableSpecData:setAllColors()
return vra,vrb,vrc,vrd,vre
end)
end
end
end
local ra,rb,rc,rd,re = superFunc(self, placeable, loadingState, args, ...)
if placeableSetColor_old ~= false then rawset(placeable, "setColor", placeableSetColor_old) end
return ra,rb,rc,rd,re
end
g_thMain:hookFunction(BuyPlaceableEvent, "new",             THBuyPlaceableEvent, nil, false)
g_thMain:hookFunction(BuyPlaceableEvent, "readStream",      THBuyPlaceableEvent)
g_thMain:hookFunction(BuyPlaceableEvent, "writeStream",     THBuyPlaceableEvent)
g_thMain:hookFunction(BuyPlaceableEvent, "placeableLoaded", THBuyPlaceableEvent)